Ruby: pm_until_node Struct Reference

Ruby 4.0.6p0 (2026-07-14 revision 03b6d3f8898a28604fe6cb00eae3226b821168f4)

Data Fields
pm_until_node Struct Reference

UntilNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_location_t | keyword_loc
| UntilNode#keyword_loc.
pm_location_t | do_keyword_loc
| UntilNode#do_keyword_loc.
pm_location_t | closing_loc
| UntilNode#closing_loc.
struct pm_node * | predicate
| UntilNode#predicate.
struct pm_statements_node * | statements
| UntilNode#statements.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

UntilNode.

Represents the use of the until keyword, either in the block form or the modifier form.

    bar until foo
    ^^^^^^^^^^^^^

    until foo do bar end
    ^^^^^^^^^^^^^^^^^^^^

Type: ::PM_UNTIL_NODE

Flags (#pm_loop_flags):

- ::PM_LOOP_FLAGS_BEGIN_MODIFIER

Definition at line 7804 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_until_node::base

The embedded base node.

Definition at line 7806 of file ast.h.

Referenced by pm_dump_json().

## ◆ closing_loc

pm_location_t pm_until_node::closing_loc

UntilNode#closing_loc.

Definition at line 7822 of file ast.h.

Referenced by pm_dump_json().

## ◆ do_keyword_loc

pm_location_t pm_until_node::do_keyword_loc

UntilNode#do_keyword_loc.

Definition at line 7817 of file ast.h.

Referenced by pm_dump_json().

## ◆ keyword_loc

pm_location_t pm_until_node::keyword_loc

UntilNode#keyword_loc.

Definition at line 7812 of file ast.h.

Referenced by pm_dump_json().

## ◆ predicate

struct pm_node* pm_until_node::predicate

UntilNode#predicate.

Definition at line 7827 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ statements

struct pm_statements_node* pm_until_node::statements

UntilNode#statements.

Definition at line 7832 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h